#!/usr/bin/env python

from __future__ import print_function, division
import os, os.path, subprocess, tempfile, sys, shutil

outpath = os.path.abspath(sys.argv[1])

# Get the SVN url of the root of the distribution
if os.path.dirname(__file__) != '':
    os.chdir(os.path.dirname(__file__))

cmd = ['svn', 'info']
print(' '.join(cmd))
proc = subprocess.Popen(cmd, stdout = subprocess.PIPE)
for line in proc.stdout:
    if len(line) > 4 and line[:4] == 'URL:':
        url = line[4:].strip()
proc.wait()

# Export distribution in temp directory
tmpdir = tempfile.mkdtemp()
os.chdir(tmpdir)

cmd = ['svn', 'export', url, 'stiefel']
print(' '.join(cmd))
subprocess.call(cmd)

# Build tar
cmd = ['tar', '-acf', outpath, 'stiefel']
print(' '.join(cmd))
subprocess.call(cmd)

# Cleanup
shutil.rmtree(tmpdir)
