#ifndef __GRAPH_ADJACENCY_CSC_H__
#define __GRAPH_ADJACENCY_CSC_H__

#include "graph.h"

/**
 * Create a graph with CSR adjacency matrix.
 *
 * @arg @c V Initial vertex count.
 * @arg @c E Initial edge count.
 * @arg @c directed Whether the represent graph will be directed.
 * @arg @c sort Whether to sort the individual neighborhoods.
 * @arg @c edges Initial edge set.
 */
graph *graph_adjacency_csr_create(
  size_t V, size_t E,
  bool directed, bool sort,
  const edge_t *edges);

/**
 * Create a graph with a CSR adjacency matrix, cloning an arbitrary graph.
 */
graph *graph_adjacency_csr_clone(graph *, bool sort);

#endif // #ifndef __GRAPH_ADJACENCY_CSC_H__
