#include <stdio.h>

#include "clustering_graph.h"
#include "knn.h"
#include "epsgraph.h"
#include "util/vptree.h"
#include "connected_components.h"

graph *graph_clustering(int V, int k, int max_nodes, void *user_data,
                        double (*distance)(void *user_data, int i, int j),
                        double (*weight)(void *user_data, int i, int j))
{
  int *component, ncomponents;
  graph *G;

  // Build initial k-nn graph.
  G = graph_build_knn(V, k, max_nodes, 1, user_data, distance, weight);

  // Get connected components
  component = (int *)malloc(sizeof(int) * V);
  ncomponents = graph_connected_components(G, component);

  fprintf(stderr, "ncomponents = %d\n", ncomponents);

  // TODO

  // Cleanup
  free(component);

  return G;
}

graph *graph_distance_clustering(
  int V, double epsilon, void *user_data,
  double (*distance)(void *user_data, int i, int j),
  double (*weight)(void *user_data, int i, int j))
{
  int *component, ncomponents;
  graph *G;

  // Build initial k-nn graph.
  G = graph_build_epsilon(V, epsilon, user_data, distance, weight);

  // Get connected components
  component = (int *)malloc(sizeof(int) * V);
  ncomponents = graph_connected_components(G, component);

  fprintf(stderr, "\nncomponents = %d\n", ncomponents);

  // TODO

  // Cleanup
  free(component);

  return G;
}
