#ifndef __GRAPH_CONNECTED_COMPONENTS_H__
#define __GRAPH_CONNECTED_COMPONENTS_H__

#include "graph.h"

/**
 * Label vertices in the graph by connected components.
 *
 * @arg @c component On input, an array of size graph_vertex_count(G).
 *                   On output, is filled with a labeling such that
 *                   component[u] == component[v] iff u and v are connected
 *                   in G.  Ignored if NULL.
 *
 * @note Runs in O(V log V) time and O(V) memory.
 * @return The total number of connected components.
 * @todo Reference to graph_vertex_count
 */
int graph_connected_components(graph *G, int *component);

#endif // #ifndef __GRAPH_CONNECTED_COMPONENTS_H__
