#ifndef __EPSGRAPH_H__
#define __EPSGRAPH_H__

#include "graph.h"

/**
 * Build a epsilon-distance graph among V nodes.
 *
 * Builds a graph for all pairs of nodes within a given distance epsilon.
 *
 * @arg @c distance A function which provides the distance between nodes i and j
 * @arg @c weight Provides the weighting for a pair of nodes i and j. 
 *                May be set to NULL, in which case this will set all edge
 *                weights to 1.
 */
graph *graph_build_epsilon(int V, double epsilon, void *user_data,
                           double (*distance)(void *user_data, int i, int j),
                           double (*weight)(void *user_data, int i, int j));

#endif /* #ifndef __EPSGRAPH_H__ */
