#!/usr/bin/env python

"""
 Utility to reweight graphs according to a radial basis function.
 
 Output is a graph with the same edges, with each new weight equal to
 
   exp(-w^2/(2*sigma^2))
 
 for old weight w and provided sigma.
"""

import sys
from math import exp

sigma = float(sys.argv[1])
Gin = file(sys.argv[2], 'r')
Gout = file(sys.argv[3], 'w+')

header = Gin.readline()
Gout.write(header)

denom = 2 * sigma * sigma;
for line in Gin:
    u,v,w = tuple(line.strip().split())

    w = float(w)
    w = exp(-(w*w)/denom)

    Gout.write('%s %s %.8e\n' % (u,v,w))

