#include "util.h"

static int compare_edges_u(const void *p1, const void *p2)
{
  const edge_t *e1, *e2;

  e1 = (const edge_t *)p1;
  e2 = (const edge_t *)p2;

  return e1->u - e2->u;
}

void graph_sort_edges_u(size_t n, edge_t *e)
{
  qsort(e, n, sizeof(edge_t), &compare_edges_u);
}

static int compare_edges_v(const void *p1, const void *p2)
{
  const edge_t *e1, *e2;

  e1 = (const edge_t *)p1;
  e2 = (const edge_t *)p2;

  return e1->v - e2->v;
}

void graph_sort_edges_v(size_t n, edge_t *e)
{
  qsort(e, n, sizeof(edge_t), &compare_edges_v);
}

static int compare_numbered_edges_u(const void *p1, const void *p2)
{
  const numbered_edge_t *e1, *e2;

  e1 = (const numbered_edge_t *)p1;
  e2 = (const numbered_edge_t *)p2;

  return e1->e.u - e2->e.u;
}

void graph_sort_numbered_edges_u(size_t n, numbered_edge_t *ne)
{
  qsort(ne, n, sizeof(numbered_edge_t), &compare_numbered_edges_u);
}

static int compare_numbered_edges_v(const void *p1, const void *p2)
{
  const numbered_edge_t *e1, *e2;

  e1 = (const numbered_edge_t *)p1;
  e2 = (const numbered_edge_t *)p2;

  return e1->e.v - e2->e.v;
}

void graph_sort_numbered_edges_v(size_t n, numbered_edge_t *ne)
{
  qsort(ne, n, sizeof(numbered_edge_t), &compare_numbered_edges_v);
}
