#ifndef __GRAPH_UTIL_H__
#define __GRAPH_UTIL_H__

#include "graph.h"
#include "graph_internal.h"

/**
 * Sort edge by just the @c u property.
 *
 * @arg @c perm On output, original positions of the edges.
 */
void graph_sort_edges_u(size_t n, edge_t *e);

/**
 * Sort edge by just the @c v property.
 *
 * @arg @c perm On output, original positions of the edges.
 */
void graph_sort_edges_v(size_t n, edge_t *e);

/**
 * Sort numbered edges by just the @c u property.
 */
void graph_sort_numbered_edges_u(size_t n, numbered_edge_t *ne);
/**
 * Sort numbered edges by just the @c v property.
 */
void graph_sort_numbered_edges_v(size_t n, numbered_edge_t *ne);

#endif // #ifndef __GRAPH_UTIL_H__
