function V = clusterV(idx, p)
    % V = clusterV(idx, p)
    %
    %    Create an orthonormal matrix V corresponding to the clustering
    %    idx.
    
    n = numel(idx);
    
    % Count the size of each cluster
    count = histc(idx, (1:p+1) - 0.5);
    count = count(1:end-1);
    
    v = 1./sqrt(count);
    V = sparse(1:n, idx, v(idx), n, p);
    V = full(V);
end