function cluster_plot(X, assign, C, indices)
    % cluster_plot(X, assign, C, indices)

    if ~exist('indices')
        indices = [1 2];
    end
        

    labels = unique(assign);
    k = numel(labels);
    drawing = {'r+', 'b+', 'k+', 'g+', 'c+', 'm+', 'y+', 'r^', 'b^', 'k^'};

    if length(indices) == 2
        for j=1:k
            scatter(X(indices(1), assign == labels(j)), X(indices(2), assign == labels(j)), drawing{j});
            hold on
        end
    elseif length(indices) == 3
        for j=1:k
            scatter3(X(indices(1), assign == labels(j)), ...
                X(indices(2), assign == labels(j)), ...
                X(indices(3), assign == labels(j)), ...
                drawing{j});
            hold on
        end
    end
    hold off
end