function [dist adj] = distance_graph(X, max_dist)
    if ~exist('max_dist', 'var')
        max_dist = inf;
    end

    [d n] = size(X);

    dot = X' * X;
    dist = repmat(diag(dot), 1, n);
    dist = dist + repmat(diag(dot)', n, 1);
    dist = dist - 2 * dot;
    
    adj = dist < max_dist;
    adj = adj - eye(n);
    dist(adj == 0) = 0;
end