function V = general_randorth(B, p)
    % V = general_randorth(B, p)
    %
    %   Create a random n x p matrix V which is orthogonal wrt the
    %   n x n matrix B, ie V' * B * V = eye(n)
    %

    n = size(B, 1);
    assert(n == size(B, 2));
    
    V = zeros(n, p);
    for i=1:p
        V(:, i) = rand(n, 1);
        for j=1:(i-1)
            V(:, i) = V(:, i) - (V(:, i)' * B * V(:, j)) * V(:, j);
        end
        V(:, i) = V(:, i) / sqrt(V(:, i)' * B * V(:, i));
    end
end