function [X y] = gmm_sample(n, k, d, sigma)
    % [X y] = gmm_sample(n, k, d, sigma)
    %
    %   Sample from a simple gaussian mixture model.
    %

    if nargin < 3
        d = 2;
    end
    if nargin < 4
        sigma = 1e-1;
    end

    y = randsample(k, n, true);
    
    mu = rand(k, d);
    sigma = sigma * eye(d);
    
    for i=1:k
        m = sum(y == i);
        X(:, y == i) = mvnrnd(mu(i, :), sigma, m)';
    end
end