function d = guess_maxdist(X, p, sample)
    [d n] = size(X);
    
    if ~exist('p', 'var')
        p = 16 * n / (n * n);
    end
    assert(p > 0);
    p = min(p, 1);
    if ~exist('sample', 'var')
        sample = 8*n;
    end
    
    % Sample pairs
    i = randsample(n, sample, 1);
    j = randsample(n-1, sample, 1);
    j(j >= i) = j(j >= i) + 1;
    
    % Get distances
    d = sqrt(sum((X(:, i) - X(:, j)) .^ 2));
    d = sort(d);
    
    % Get distance at p
    d = d(ceil(sample * p));
end