#include "bits/mex_interface.h"
#include "bits/mex_convert.h"
#include "bits/sparse_convert.h"

#include "util/matio.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  char *path;
  cs_di *A;

  /* Interpret arguments */
  mex_assert(nrhs == 1);
  path = mxArrayToString(prhs[0]);
  mex_assert(path != NULL);

  /* Load matrix */
  mexPrintf("Reading \"%s\"\n", path);
  A = sparsemat_file_read_all_path(path);
  mex_assert(A != NULL);
  
  /* Copy to output */
  plhs[0] = mxArrayFromSparse(A);
  mex_assert(plhs[0] != NULL);

  /* Cleanup */
  mxFree(path);
  cs_di_spfree(A);
}
