function [W adj] = neighbor_graph(X, k, sigma)
    [d n] = size(X);
    
    [adj dist] = knn_graph(k, X);
    dist = max(dist, dist');
    adj = adj | adj';
    
    if ~exist('sigma', 'var') || numel(sigma) == 0
        sigma = median(dist(adj ~= 0));
    end
    
    W = sparse(n, n);
    W(adj ~= 0) = exp(- dist(adj~=0).^2 / (2 * sigma^2));
end