function plot_graph(X, adj, W)

    % Get edges by coordinate
    [i j] = find(adj);
    from = X(:, i);
    to = X(:, j);
    
    % Sort in order
    dist = sum((to - from) .^ 2);
    [dist ind] = sort(dist, 2, 'descend');
    from = from(:, ind);
    to = to(:, ind);
    
    h = plot([from(1, :); to(1, :)], [from(2, :); to(2, :)], ...
        'Color', [0.5, 0.5, 0.5]);
    
    if exist('W', 'var')
        W = W(adj ~= 0);
        W = W - min(W);
        W = W / max(W);
        assert(numel(h) == numel(W));
        
        W = W(ind);
        for i=1:numel(h)
            set(h(i), 'Color', repmat(1-W(i), 1, 3));
        end
    end
end