function W = readgraph(path)
    fp = fopen(path, 'r');
    
    % Read in edges
    szs = fscanf(fp, '%d', 3);
    V = szs(1);
    E = szs(2);
    dir = szs(3);
    
    edges = fscanf(fp, '%d %d %g', [3 E]);
    fclose(fp);
    
    % Express edges as adjacency graph
    if dir
        i = edges(1, :)+1;
        j = edges(2, :)+1;
        s = edges(3, :)+1;
    else
        i = [edges(1, :)+1, edges(2, :)+1];
        j = [edges(2, :)+1, edges(1, :)+1];
        s = repmat(edges(3, :), 1, 2);
    end
    
    
    W = sparse(i, j, s, V, V);
end