#ifndef __OPTIM_BLOCK_STIEFEL_H__
#define __OPTIM_BLOCK_STIEFEL_H__

#include "params.h"
#include "msg.h"

struct stiefel_ctx;

struct stiefel_prob
{
  int n, p, k;

  void *user_data;
  double (*obj)(void *user_data, int k, int p, const int *K, const double *V, const double *Vk);
  void (*grad)(void *user_data, int k, int p, const int *K, const double *V, double *Gk);
  double (*fullobj)(void *user_data, int p, const double *V);

  optim_params params;
};

struct stiefel_ctx *block_stiefel_ctx_init(const struct stiefel_prob *prob);
void block_stiefel_ctx_deinit(struct stiefel_ctx *ctx);

double step_block(struct stiefel_ctx *ctx, const double *V, const int *K, double *Vk, const double *Gk);

void block_stiefel(const struct stiefel_prob *prob, double *V);

/*
struct cs_di_sparse;
void block_stiefel_parallel(
  const struct stiefel_prob *prob, double *V,
  int nthreads, struct cs_di_sparse *indep,
  void (*call_client)(const void *pdata, struct itermsg *msg),
  const void *pdata);

void block_stiefel_multithread(const struct stiefel_prob *prob, double *V, int nthreads, struct cs_di_sparse *indep);
*/

#endif // #ifndef __OPTIM_BLOCK_STIEFEL_H__
