#ifndef __STIEFEL_OPTIM_CAYLEY_H__
#define __STIEFEL_OPTIM_CAYLEY_H__

#include <cs.h>

/**
 * Generate Cayley curves according to (4.6) of Wen & Yin 2010
 *
 * @arg @c W m x m dense matrix
 * @arg @c M m x m sparse matrix
 * @arg @c X0 m x n dense matrix
 * @arg @c X Output argument, m x n dense matrix
 */
void stiefel_cayley_general(int m, int n, double tau, const double *W, const cs_di *M, const double *X0, double *X);

double cayley_check(const cs_di *M, int n, const double *X0, const double *X);

#endif /* #ifndef __STIEFEL_OPTIM_CAYLEY_H__ */
