#ifndef __CONFIG_H__
#define __CONFIG_H__

#include <stdio.h>
#include <stdbool.h>

typedef enum {
  CONFIG_INT,
  CONFIG_STRING,
  CONFIG_FLOAT,
  CONFIG_BOOL

} config_type;

typedef struct {
  const char *name;
  config_type type;
} config_var;

void config_read_file(FILE *fp, const config_var *vars, void **out);
void config_read_path(const char *path, const config_var *vars, void **out);

#endif // #ifndef __CONFIG_H__
