#ifndef __OPTIM_MSG_H__
#define __OPTIM_MSG_H__

#include <cs.h>
#include <stdlib.h>
#include "optim_config.h"
#include "util/rowset.h"

struct setupmsg
{
  int n, k, p;

  int nterms, *objtypes;

  config_params params;
};

size_t setupmsg_buflen(const struct setupmsg *msg);
int setupmsg_serialize(const struct setupmsg *msg, size_t buflen, void *buf);

struct setupmsg *setupmsg_deserialize(size_t buflen, const void *buf);
void setupmsg_dealloc(struct setupmsg *msg);


struct itermsg
{
  rowset *Vk;
  rowset *VnbrA;
  rowset *VnbrB;
};

size_t itermsg_buflen(const struct itermsg *msg);
int itermsg_serialize(const struct itermsg *msg, size_t buflen, void *buf);

struct itermsg *itermsg_deserialize(size_t buflen, const void *buf);
void itermsg_dealloc(struct itermsg *msg);

#endif /* #ifndef __OPTIM_MSG_H__ */
