#ifndef __STIEFEL_MUSTLINK_H__
#define __STIEFEL_MUSTLINK_H__

#include <stdio.h>
#include <stdlib.h>

typedef struct mustlink mustlink;

mustlink *mustlink_create(int nmembers);
void mustlink_destroy(mustlink *ml);

int mustlink_nmembers(const mustlink *ml);
int mustlink_ngroups(const mustlink *ml);

int mustlink_ningroups(const mustlink *ml, int i);
const int *mustlink_membership(const mustlink *ml, int i);

int mustlink_group_nmembers(const mustlink *ml, int g);
const int *mustlink_group_members(const mustlink *ml, int g);

/**
 * @return 1 if index @c i is in group @c g
 */
int mustlink_in_group(const mustlink *ml, int i, int g);

/**
 * @return Index of new group, or -1 on failure
 */
int mustlink_add_group(mustlink *ml, int nmembers, const int *members);

mustlink *mustlink_read_from_file(FILE *fp);
mustlink *mustlink_read_from_path(const char *path);

size_t mustlink_serial_length(const mustlink *ml);

/**
 * @return 0 on success, -1 on failure
 */
int mustlink_serialize(const mustlink *ml, size_t buflen, void *buf);
mustlink *mustlink_deserialize(size_t buflen, const void *buf);

#endif /* #ifndef __STIEFEL_MUSTLINK_H__  */
