#ifndef __OPTIM_CONFIG_H__
#define __OPTIM_CONFIG_H__

#include <stdio.h>
#include <stdbool.h>

#include "params.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
  optim_params optim;

  bool preload_matrices;
  bool presend_matrices;
} config_params;

extern const config_params config_default_params;

void optim_config_read_file(config_params *params, FILE *fp);
void optim_config_read_path(config_params *params, const char *path);

#ifdef __cplusplus
}
#endif

#endif /* #ifndef __OPTIM_CONFIG_H__ */
