#include <stdlib.h>
#include <assert.h>

#include "randsparse.h"


cs_di *randsparse(int n, int nnz, int symm)
{
  cs_di *A, *cA;
  int i;

  A = cs_di_spalloc(n, n, nnz, 1, 1);
  A->nz = nnz;
  if(symm) {
    nnz /= 2;
  }

  for(i = 0; i < nnz; i++) {
    A->p[i] = rand() % n;
    A->i[i] = rand() % n;
    A->x[i] = 1;

    if(symm) {
      A->p[nnz+i] = A->i[i];
      A->i[nnz+i] = A->p[i];
      A->x[nnz+i] = 1;
    }
  }

  cA = cs_di_compress(A);
  cs_di_spfree(A);

  return cA;
}
