#ifndef __OPTIM_SAMPLE_INDEPENDENT_H__
#define __OPTIM_SAMPLE_INDEPENDENT_H__

#include "util/sparsemat.h"

typedef struct independent_sampler independent_sampler;

/**
 * @arg @c adj Must be valid for lifetime of @c independent_sampler object
 */
independent_sampler *independent_sampler_create(sparsemat *adj);
void independent_sampler_destroy(independent_sampler *is);

/**
 * Sample at most @c k independent vertices.
 *
 * @arg @c nbr Output argument of neighbors of @c ind in @c adj.
 *             *nbr must be freed by caller. Ignored if NULL.
 * @returns Number of vertices sampled.
 */
int independent_sampler_sample(independent_sampler *is, int k, int *ind, int *nnbr, int **nbr);
void independent_sampler_return(independent_sampler *is, int k, const int *ind);

#endif /* #ifndef __OPTIM_SAMPLE_INDEPENDENT_H__ */
