#ifndef __STIEFEL_OPTIM_STIEFEL_PROB_H__
#define __STIEFEL_OPTIM_STIEFEL_PROB_H__

#include <stdio.h>

#include "objterm.h"
#include "util/sparsemat.h"

typedef struct stiefel_prob stiefel_prob;

struct stiefel_prob
{
  int nterms;
  termdef *objdef;

  sparsemat *B;

  int n, p;
  double *V0;
};

stiefel_prob *stiefel_prob_create(int nterms, int n, int p);
void stiefel_prob_destroy(stiefel_prob *prob);

stiefel_prob *stiefel_prob_from_file(FILE *fp, const char *basepath);
stiefel_prob *stiefel_prob_from_path(const char *path);

int stiefel_prob_nterms(const stiefel_prob *prob);
int stiefel_prob_n(const stiefel_prob *prob);
int stiefel_prob_p(const stiefel_prob *prob);

termdef *stiefel_prob_get_term(stiefel_prob *prob, int i);
const termdef *stiefel_prob_get_term_const(const stiefel_prob *prob, int i);

sparsemat *stiefel_prob_get_ortho(stiefel_prob *prob);
const sparsemat *stiefel_prob_get_ortho_const(const stiefel_prob *prob);



#endif /* #ifndef __STIEFEL_OPTIM_STIEFEL_PROB_H__ */
