#ifndef __STIEFEL_LAZY_TRACE_H__
#define __STIEFEL_LAZY_TRACE_H__

#include "util/sparsemat.h"
#include "util/rowset.h"

double trace_partial_obj(sparsemat *A, const rowset *V, const rowset *Vnbr);
void trace_partial_grad(sparsemat *A, const rowset *V, const rowset *Vnbr, double *Gk);

/**
 * Calculate trace(V' * A * V) objective over the full matrix.
 *
 * @arg @c V n x p matrix stored in row-major order
 */
double sparse_trace_full_obj(sparsemat *A, int p, const double *V);

double multitrace_partial_obj(int nmat, sparsemat **A, const rowset *V, const rowset *Vnbr);
void multitrace_partial_grad(int nmat, sparsemat **A, const rowset *V, const rowset *Vnbr, double *Gk);

#endif /* #ifndef __STIEFEL_LAZY_TRACE_H__ */
