from __future__ import print_function
from SCons.Script import *

def generate(env):
    conf = Configure(env)

    env.SetDefault(MATLABDIR = '/usr/local/MATLAB/R2013b')
    env.SetDefault(MEXINCPATH = '$MATLABDIR/extern/include')
    env.SetDefault(MEXLIBPATH = '$MATLABDIR/bin/glnxa64')
    env.AppendUnique(CPPPATH = ['$MEXINCPATH'])
    env.AppendUnique(LIBPATH = ['$MEXLIBPATH'])

    headers = ['mat.h', 'matrix.h']
    libs = ['mex', 'mx', 'mat']

    for h in headers:
        if not conf.CheckCHeader(h):
            print('Matlab library missing')
            Exit(1)

    for l in libs:
        if not conf.CheckLib(l):
            print('Matlab library missing')
            Exit(1)
    
    conf.Finish()

def exists(env):
    return True
