#ifndef __FILE_LIST_H__
#define __FILE_LIST_H__

#include <stdio.h>

typedef struct file_list file_list;

file_list *file_list_create(int length);
void file_list_destroy(file_list *fl);

/**
 * Load a list of paths from a file.
 */
file_list *file_list_load(const char *path);
file_list *file_list_load_fp(FILE *fp);

/**
 * Save a list of paths to a file
 */
void file_list_write_fp(FILE *fp, const file_list *fl);

//////////////////////////////// Accessors ////////////////////////

int file_list_length(const file_list *fl);
const char *file_list_get(const file_list *fl, int i);
void file_list_set(file_list *fl, int i, const char *s);

file_list *file_list_merge(const file_list *a, const file_list *b);
file_list *file_list_sample(const file_list *fl, int n, const int *indices);
file_list *file_list_randsample(const file_list *fl, int n, int replacement);

#endif // #ifndef __FILE_LIST_H__
