#include <sysexits.h>
#include <stdio.h>
#include <stdlib.h>

#include "file_list.h"

static const char * const USAGE = "file-list-sample <n> <file list>\n";

int main(int argc, char **argv)
{
  int i, m, n, *ind;
  file_list *fl, *sub;

  srand(0);

  if(argc != 3) {
    fprintf(stderr, "Usage error: %s\n", USAGE);
    return EX_USAGE;
  }

  // Load input
  n = atoi(argv[1]);
  fl = file_list_load(argv[2]);

  // Construct sample
  sub = file_list_randsample(fl, n, 0);

  // Write output to stdout
  file_list_write_fp(stdout, sub);

  // Cleanup
  file_list_destroy(sub);
  file_list_destroy(fl);

  return 0;
}
