#include <assert.h>
#include <sysexits.h>
#include <stdio.h>

#include "matio.h"

static const char * const USAGE = "ident <n> <outpath>";

int main(int argc, char **argv)
{
  int i, n;
  const char *path;
  cs_di *ident;

  // Interpret arguments
  if(argc != 3) {
    fprintf(stderr, "Usage: %s\n", USAGE);
    return EX_USAGE;
  }

  n = atoi(argv[1]);
  path = argv[2];

  // Build matrix
  ident = cs_di_spalloc(n, n, n, 1, 0);
  for(i = 0; i < n; i++) {
    ident->p[i] = i;
    ident->i[i] = i;
    ident->x[i] = 1;
  }
  ident->p[n] = n;
  assert(ident->nz == -1);

  // Write to file
  sparsemat_write_binary_path(path, ident);

  // Cleanup
  //cs_di_spfree(ident);

  return 0;
}
