#ifndef __UTIL_INTARRAY_H__
#define __UTIL_INTARRAY_H__

typedef struct intarray intarray;

intarray *intarray_create(int n);
intarray *intarray_create_from(int n, int *v);
intarray *intarray_clone(const intarray *Ia);
void intarray_destroy(intarray *Ia);

int intarray_length(const intarray *Ia);
void intarray_resize(intarray *Ia, int n);

int intarray_get(const intarray *Ia, int i);
int *intarray_contents(intarray *Ia);
const int *intarray_contents_const(const intarray *Ia);

void intarray_append(intarray *Ia, int n, const int *Ja);

intarray *intarray_unique(intarray *Ia);
void intarray_unique_update(intarray *Ia);

#endif /* #ifndef __UTIL_INTARRAY_H__ */
