#ifndef __CLUSTER_KMEANS_UTIL_H__
#define __CLUSTER_KMEANS_UTIL_H__

#include <stdlib.h>

/**
 * Find the k-means centers given a partition.
 */
void cluster_centers(
  size_t n, size_t ndims, const double *p, const double *w,
  size_t k, const int *part, double *C);

/**
 * A vector all of 1's to serve as dummy weights.
 *
 * @note Caller must free result.
 */
double *ones_vector(size_t n);

/**
 * Normalize partitions to range in [0,k) and return k
 *
 * k is the number of unique parts
 */
size_t normalize_part(size_t n, int *part);

#endif // #ifndef __CLUSTER_KMEANS_UTIL_H__
