#ifndef __MATIO_H__
#define __MATIO_H__

#include <stdio.h>
#include <cs.h>

void sparsemat_write_to_file(FILE *fp, cs_di *A);
void sparsemat_write_to_path(const char *path, cs_di *A);


/* Sparse matrix which lives on disk */

/**
 * @return 0 on success, other on failure
 */
int sparsemat_write_binary_file(FILE *fp, cs_di *A);
int sparsemat_write_binary_path(const char *path, cs_di *A);

typedef struct sparsemat_file sparsemat_file;

sparsemat_file *sparsemat_open_binary_file(const char *path);
void sparsemat_close_binary_file(sparsemat_file *fp);

void sparsemat_file_dims(sparsemat_file *fp, int dims[2]);
int sparsemat_file_nnz(sparsemat_file *fp);
int sparsemat_file_colnnz(sparsemat_file *fp, int col);
void sparsemat_file_get_col(sparsemat_file *fp, int col, int *i, double *v);

cs_di *sparsemat_file_read_all(sparsemat_file *fp);
cs_di *sparsemat_file_read_all_path(const char *path);

#endif /* #ifndef __MATIO_H__ */
