#include <stdio.h>
#include <stdlib.h>
#include <sysexits.h>
#include <string.h>
#include <assert.h>
#include <stdint.h>

#include "randorth.h"
#include "denseio.h"
#include "matio.h"

const char * const USAGE = "randorth <n> <p> <txt|bin> <output> [<B>]";

int main(int argc, char **argv)
{
  int n, p, bin;
  const char *outpath;
  double *V;
  cs_di *B;

  // Interpret arguments
  if(!(argc == 5 || argc == 6)) {
    fprintf(stderr, "Usage: %s\n", USAGE);
    return EX_USAGE;
  }

  n = atoi(argv[1]);
  p = atoi(argv[2]);
  if(strcmp(argv[3], "txt") == 0) {
    bin = 0;
  }
  else if(strcmp(argv[3], "bin") == 0) {
    bin = 1;
  }
  else {
    fprintf(stderr, "Argument 3 must be either \"txt\" or \"bin\"\nUsage: %s\n", USAGE);
    return EX_USAGE;
  }
  outpath = argv[4];

  B = NULL;
  if(argc >= 6) {
    B = sparsemat_file_read_all_path(argv[5]);
  }


  // Generate matrix
  V = (double *)malloc(sizeof(double) * n * p);

  if(B == NULL) {
    randorth(n, p, V);
  }
  else {
    randgenorth(B, p, V);
  }

  // Output
  dense_file_write(outpath, bin, n, p, V);

  // Cleanup
  free(V);

  return 0;
}
