#include <assert.h>

#include "setdiff.h"
#include "debug.h"


void indsetdiff(int n, int k, const int *indS, int *diffS)
{
  int i, j, l;

  j = 0; l = 0;
  for(i = 0; i < n; i++) {
    if(j < k && indS[j] == i) {
      j++;
    }
    else {
      assert(j == k || indS[j] > i);
      diffS[l++] = i;
    }
  }
}

void intsetdiff(int m, const int *A, int n, const int *B, int *outk, int *diff)
{
  int i, j, k;

  assert(issorted(m, A));
  assert(issorted(n, B));

  j = 0, k = 0;
  for(i = 0; i < m; ) {
    if(j == n || A[i] < B[j]) {
      diff[k] = A[i];
      i++; k++;
    }
    else if(A[i] == B[j]) {
      i++; j++;
    }
    else {
      j++;
    }
  }


  *outk = k;
}
