#ifndef __UTIL_SETDIFF_H__
#define __UTIL_SETDIFF_H__

/**
 * Find all elements of the integers 0,1,...,n-1 not in indS
 *
 * @arg @c k The number of elements in indS
 * @arg @c indS Subtrahend set.  Subset of integers [0,n) in ascending order.
 * @arg @c diffS Output argument of the elements.  Must have space for n-k 
 *               elements.
 */
void indsetdiff(int n, int k, const int *indS, int *diffS);

/**
 * Find the set difference A - B
 *
 * @note A and B must be sorted in ascending order
 * @arg @c diff Output argument, should have room for @c m entries
 */
void intsetdiff(int m, const int *A, int n, const int *B, int *l, int *diff);

#endif /* #ifndef __UTIL_SETDIFF_H__ */
