#include "sparsemat_internal.h"

void sparsemat_destroy(sparsemat *M)
{
  if(M == NULL) {
    return;
  }

  M->v->destroy(M);
}

void sparsemat_dims(const sparsemat *M, int dims[2])
{
  dims[0] = M->dims[0];
  dims[1] = M->dims[1];
}

int sparsemat_nrows(const sparsemat *M)
{
  return M->dims[0];
}

int sparsemat_ncols(const sparsemat *M)
{
  return M->dims[1];
}

sparsecol sparsemat_col(sparsemat *M, int j)
{
  sparsecol col;

  if(j < 0 || j >= M->dims[1]) {
    col.nnz = -1;
    col.i = NULL;
    col.v = NULL;
    return col;
  }

  return M->v->getcol(M, j);
}

double sparsemat_entry(sparsemat *M, int i, int j)
{
  sparsecol Mj;
  int k;

  Mj = sparsemat_col(M, j);
  for(k = 0; k < Mj.nnz; k++) {
    if(Mj.i[k] == i) {
      return Mj.v[k];
    }
  }

  return 0;
}
