#ifndef __VPTREE_PARALLEL__
#define __VPTREE_PARALLEL__

#include "vptree.h"

/**
 * Add multiple entries to a vp-tree simultaneously.
 *
 * Optimally splits at each level using all available data.
 *
 * @note Pointers @c p[0] to @c p[n-1] must be valid for the lifetime of the vp-tree
 */
void vptree_add_many_parallel(vptree *vp, int n, const void * const *p, int nthreads);

#endif /* #ifndef __VPTREE_PARALLEL__ */
